/// <reference path="../ext-6.0.2-classic.d.ts" />

/**
 * The main application class. An instance of this class is created by app.js when it
 * calls Ext.application(). This is the ideal place to handle application launch and
 * initialization details.
 */
Ext.define('LMSplaylistEditor.Application', {
	extend: 'Ext.app.Application',
	requires: ['LMSplaylistEditor.RuntimeConfig','LMSplaylistEditor.controller.SlimSearchController','LMSplaylistEditor.Utils'],

    name: 'LMSplaylistEditor',

    quickTips: false,
    platformConfig: {
        desktop: {
            quickTips: true
        }
    },


	models: ['SlimSong', 'SlimAlbum', 'SlimPlaylists', 'SlimGenre', 'SlimArtist'],
	stores: ['TrackSearchResults', 'AlbumSearchResults', 'AllPlaylists', 'AllGenres','AllArtists', 'AllAlbums', 'ArtistSearchResults', 'AlbumNewMusic'],
//	controllers: ['SlimSearchController'],

	init: function () {
		  // TODO - Launch the application

		  /*
		console.log( "Application init: StoreManager");
		Ext.data.StoreManager.eachKey( function(key, item, index, len) {
			console.log("key="+key);
			console.dir( item);
		});
		*/
    },

    launch: function () {
		  // TODO - Launch the application
		/*
		var store = this.getStore("AllArtists");
		if( store) {
			console.dir( store);
			//console.log( "store:name="+store.getName());
		}
		Ext.each( this.stores, function( v) {
			console.log( "store:v="+v);
			var store = Ext.getStore( v);
			if( store) {
				console.log( "store:name="+store.getName());
				store.getProxy().on('exception', LMSplaylistEditor.Utils.storeQueryException, store);
			}
		});
		*/
		/*
		console.log( "Application launch: StoreManager");
		Ext.data.StoreManager.eachKey( function(key, item, index, len) {
			console.log("key="+key);
			console.dir( item);
		});
		*/
//		this.setMainView( Ext.create('LMSplaylistEditor.view.main.Main'));
//		this.setMainView( Ext.create('LMSplaylistEditor.view.MainView'));

		// FIXME: ugly
		if(top != self) top.location.replace(location);

		Ext.ariaWarn = Ext.emptyFn;

		LMSplaylistEditor.Utils.checkEGVersion();
		LMSplaylistEditor.Utils.checkPlayersAvailable();
		LMSplaylistEditor.Utils.getLPEVersion();

    },

    onAppUpdate: function () {
        Ext.Msg.confirm('Application Update', 'This application has an update, reload?',
            function (choice) {
                if (choice === 'yes') {
                    window.location.reload();
                }
            }
        );
    }
});
