/// <reference path="../../ext-6.0.2-classic.d.ts" />

Ext.define('LMSplaylistEditor.controller.SlimCurrentPlaylistController', {
	extend: 'Ext.app.ViewController',
	alias: 'controller.SlimCurrentPlaylistController',
//	requires: ['LMSplaylistEditor.ux.SlimWinPlaylistSelect', 'LMSplaylistEditor.Utils'],
	requires: ['LMSplaylistEditor.Utils'],

	plsSelectWin: undefined,

	onRemoveButtonClick: function ( button) {
		var s = this.getView().getStore();
		var sm = this.getView().getSelectionModel();
		s.remove( sm.getSelection());
	},
	onClearNotifyDrop: function(ddSource, e, data){
		// data.records[0].get('playlist')
		if (data.records && data.records.length == 1 && data.records[0].data.hasOwnProperty('playlist') ) {
			var pStore = Ext.data.StoreManager.lookup('AllPlaylists');
			Ext.Msg.show({
				title: 'Delete Playlist',
				msg: 'Really delete playlist \"'+data.records[0].get('playlist')+'\" ?',
				prompt: false,
//				width: 300,
				buttons: Ext.Msg.YESNO,
				multiline: false,
				fn: function( button) {
					if( button == 'yes') {
						console.log('delete playlist_id:'+data.records[0].get('id'));
						var f = function( options, success, response) {
							console.log("delete playlist success="+success);
							//console.dir( response);
							if( success) {
								pStore.reload();
							}
						};
						LMSplaylistEditor.Utils.slimRequest( { params: ['playlists', 'delete', 'playlist_id:'+data.records[0].get('id')], scope: this, callback: f });
					}
				},
				//animateTarget: 'tbar-button-playlist-clear',
				icon: Ext.Msg.WARNING,
				scope: this
			});
			return true;
		} else {
			return false;
		}
	},
	onAddNotifyDrop: function(ddSource, e, data){
		if (data.records && data.records.length > 0) {
			/*
			console.dir( data.records);
			var dbSearchString = [];
			var dbAttString = [];
			var filters ={};

			var fr = this.lookupReference('filters_rating');
			var rv = fr.getValues();
			Object.assign( filters, { ratings: { ratingFrom: rv[0], ratingTo: rv[1] } });

			LMSplaylistEditor.Utils.buildDBCondition( dbSearchString, dbAttString, data.records, filters);
			var s = this.getView().getStore();
			s.loadTracksByQuery( dbSearchString, dbAttString);
			*/
			/*
			if (data.records[0].get('albumid')) {
			} else if (data.records[0].get('contributor')) {
			} else if (data.records[0].get('playlist')) {
			} else if (data.records[0].get('genre')) {
			} else if (data.records[0].get('artist')) {
			}
			*/
			/*
			var mode = SlimGUI.config.PLS_MOD_MODE_ADD;
			if (e.ctrlKey ) {
				mode = SlimGUI.config.PLS_MOD_MODE_INSERT;
			}
			*/
			this.fireViewEvent('loadTracksByQuery', this, data.records, LMSplaylistEditor.RuntimeConfig.config.OPS_MODE_ADD, undefined);

		}
		return true;
	},
	onInsertObjectsIntoPlaylist: function( records, idx) {
		console.log('SlimCurrentPlaylistController onInsertObjectsIntoPlaylist');
		this.fireViewEvent('loadTracksByQuery', this, records, LMSplaylistEditor.RuntimeConfig.config.OPS_MODE_INSERT, idx);
	},
	onCurrentPlaylistTrackSelected: function( record, item, index) {
		console.log('SlimCurrentPlaylistController onCurrentoPlaylistTrackSelected');
		console.dir( record);
		this.fireViewEvent('currentPlaylistSelectedTrackChange', this, record);
	},
	onLoadPlaylistButtonClick: function ( button) {
		if( !this.plsSelectWin) {
			this.plsSelectWin = Ext.create( 'LMSplaylistEditor.ux.SlimWinPlaylistSelect');
			this.plsSelectWin.on( 'plsSelectLoadPlaylist', this.onPlaylistLoadSelected, this);
		}
		this.plsSelectWin.show();
	},
	onPlaylistLoadSelected: function( selPlaylists, mode) {
		//console.dir( selPlaylists);
		//var s = this.lookupReference('slim_grid_current_playlist').getStore();
		var s = this.getView().getStore();
		//console.dir( s);
		s.loadPlaylist( selPlaylists[0], mode, undefined);
	},
	onSavePlaylistButtonClick: function ( button) {
		var s = this.getView().getStore();
		if( s.getCount() == 0) {
			this.getView().showPlaylistSaveInfo( 'No tracks to save.');
			return;
		}
		var tracks = [];
		var that = this;
		var player = 'dummy';

		s.each( function( rec) {
//			console.log("rec id:"+rec.get('id')+' title:'+rec.get('name'));
			tracks.push( rec.get('id'));
		});

		var pStore = Ext.data.StoreManager.lookup('AllPlaylists');

		Ext.Msg.show({
			title: 'Save Playlist',
			msg: 'Playlist name:',
			prompt: true,
			width: 300,
			buttons: Ext.Msg.OKCANCEL,
			multiline: false,
			fn: function( button, text) {
				if( button == 'ok' && text) {
					if (pStore.findExact('playlist', text) != -1) {
						Ext.Msg.show({
							title: 'Save Playlist',
							msg: 'Playlist \"'+text+'\" exists. Overwrite?',
							prompt: false,
							width: 300,
							buttons: Ext.Msg.YESNO,
							multiline: false,
							fn: function( button) {
								if( button == 'yes') {
									Ext.data.JsonP.request({
										url: LMSplaylistEditor.RuntimeConfig.config.JSONPURL,
										params: {
											args: Ext.JSON.encode({
												cmd: 'saveTracksAsPlaylist',
												player: player,
												trackids: tracks,
												plsname: text
											})
										},
										success: function(response, opts) {
											console.dir( response);
											if( !response.error) {
												that.getView().showPlaylistSaveInfo( 'Playlist [' + text + '] saved (' +  response.result.count +' tracks).');
											} else {
												that.getView().showPlaylistSaveInfo( 'Error saving playlist [' + text + '] ' + Ext.JSON.encode( response));
											}
										},
										failure: function(response, opts) {
											console.log('server-side failure:');
											console.dir( response);
											that.getView().showPlaylistSaveInfo( 'Error saving playlist [' + text + '] ' + Ext.JSON.encode( response));
										},
										scope: that
									});

								}
							},
							animateTarget: 'tbar-button-playlist-save',
							icon: Ext.Msg.WARNING,
							scope: this
						});
					} else {
						Ext.data.JsonP.request({
							url: LMSplaylistEditor.RuntimeConfig.config.JSONPURL,
							params: {
								args: Ext.JSON.encode({
									cmd: 'saveTracksAsPlaylist',
									player: player,
									trackids: tracks,
									plsname: text
								})
							},
							success: function(response, opts) {
								console.dir( response);
								if( !response.error) {
									that.getView().showPlaylistSaveInfo( 'Playlist [' + text + '] saved (' +  response.result.count +' tracks).');
								} else {
									that.getView().showPlaylistSaveInfo( 'Error saving playlist [' + text + '] ' + Ext.JSON.encode( response));
								}
							},
							failure: function(response, opts) {
								console.log('server-side failure:');
								console.dir( response);
								that.getView().showPlaylistSaveInfo( 'Error saving playlist [' + text + '] ' + Ext.JSON.encode( response));
							},
							scope: that
						});
						pStore.reload();
					}
				}
			},
//			animateTarget: 'tbar-button-playlist-save',
			icon: Ext.Msg.QUESTION,
			scope: this
		});

	},
	onClearPlaylistButtonClick: function ( button) {
		var s = this.getView().getStore();
		s.clearFilter();
		s.removeAll();
	}

});