Ext.define('LMSplaylistEditor.controller.SlimSearchController', {
	extend: 'Ext.app.ViewController',
	alias: 'controller.SlimSearchController',
	requires: ['LMSplaylistEditor.RuntimeConfig'],

	onArtistSearchButtonClick: function ( button) {
		var f = this.lookupReference('artistsearchresults_field_artist_name');
		var v = this.getView();
//		console.dir( v);
		v.search( f.getValue());
		console.log("onArtistSearchButtonClick");
//		this.fireViewEvent('onArtistSearchButtonClick', this, f.getValue());
	},
	onArtistSearchFieldSubmit: function(f, e) {
		if (e.getKey() == e.ENTER && f.getValue()) {
			var v = this.getView();
			v.search( f.getValue());
		}
	},
	onAlbumSearchButtonClick: function ( button) {
		var f = this.lookupReference('albumsearchresults_field_album_name');
		var v = this.getView();
		v.search( f.getValue());
	},
	onAlbumSearchFieldSubmit: function(f, e) {
		if (e.getKey() == e.ENTER && f.getValue()) {
			var v = this.getView();
			v.search( f.getValue());
		}
	},
	onTrackSearchButtonClick: function ( button) {
		var f = this.lookupReference('tracksearchresults_field_track_name');
		var v = this.getView();
		v.search( f.getValue());
	},
	onTrackSearchFieldSubmit: function(f, e) {
		if (e.getKey() == e.ENTER && f.getValue()) {
			var v = this.getView();
			v.search( f.getValue());
		}
	},
	onSearchArtistsDoubleClick: function (  sender, record, item, index) {
		console.log("onSearchArtistsDoubleClick");
		console.dir( record);
		this.fireViewEvent('showAlbumsByArtist', this, record);
	},
	onSearchAlbumsDoubleClick: function (  sender, record, item, index) {
		console.log("onSearchAlbumsDoubleClick");
		console.dir( record);
		this.fireViewEvent('showTracksByAlbum', this, record);
	},
	onTrackSearchResultNavigateBack: function( button) {
		this.fireViewEvent('switchToLastView', this, LMSplaylistEditor.RuntimeConfig.config.NAVTYPE_TRACK);
	},
	onAlbumSearchResultNavigateBack: function( button) {
		this.fireViewEvent('switchToLastView', this, LMSplaylistEditor.RuntimeConfig.config.NAVTYPE_ALBUM);
	},
	
	onCustomSearchButtonClick: function ( button) {
		var v = this.getView();
		if( v.allConds.length == 0) {
			Ext.Msg.show({
				title: 'Custom Search',
				msg: 'At least one condition must be specified.',
				prompt: false,
				animateTarget: 'panelsearchcustom-button-custsearch',
				buttons: Ext.Msg.OK,
				multiline: false,
				icon: Ext.Msg.INFO
			});
			return;
		}
		var args = v.getSearchParms();
		//console.dir( args);
		if( v.searchForTracks ) {
			/*
			this.prevTrackPanel = "#PanelSearchCustom";
			this.getPanelMusicSearch().setActiveTab('SlimGridTrackSearchResults');
			this.getGridTrackSearchResults().showTracksByCustomSearch( args);
			*/
			this.fireViewEvent('showTracksByCustomSearch', this, args);
		} else {
			/*
			this.prevAlbumPanel = "#PanelSearchCustom";
			this.getPanelMusicSearch().setActiveTab('SlimGridAlbumSearchResults');
			this.getGridAlbumSearchResults().showTracksByCustomSearch( args);
			*/
			this.fireViewEvent('showAlbumsByCustomSearch', this, args);
		}
	},
	onCustomSearchAddCondGenre: function() {
		var v = this.getView();
		v.addCondition( LMSplaylistEditor.ux.PanelSearchCustomItem.TYPE_GENRE);
	},
	onCustomSearchAddCondArtist: function() {
		var v = this.getView();
		v.addCondition( LMSplaylistEditor.ux.PanelSearchCustomItem.TYPE_ARTIST);
	},
	onCustomSearchAddCondYear: function() {
		var v = this.getView();
		v.addCondition( LMSplaylistEditor.ux.PanelSearchCustomItem.TYPE_YEAR);
	},
	onCustomSearchAddCondRating: function() {
		var v = this.getView();
		v.addCondition( LMSplaylistEditor.ux.PanelSearchCustomItem.TYPE_RATING);
	}

});