
Ext.define('LMSplaylistEditor.ux.PanelFilters', {
	extend: 'Ext.panel.Panel',
	requires: [ 'Ext.form.field.Checkbox', 'Ext.slider.Multi'],
	/*
	title: "Filters",
	id: "panel-filters",
	reference: "panel_filters",
	*/
	//autoDestroy: false,
	items: [
		{
			xtype: 'panel',
			layout: {
				type: 'hbox',
				align: 'stretch'
			},
			items: [
				{  xtype: 'checkboxfield', id: 'check-filters-rating' },
				{
					xtype: 'multislider',
					id: 'slider-filters-rating',
					reference: 'filters_rating',
					fieldLabel: 'Rating',
					labelWidth: 50,
					name: 'rating',
					values: [0, 5],
					increment: 1,
					minValue: 0,
					maxValue: 5,
					constrainThumbs: true,
					disabled: true,
/*					border: 2,
					style: {
						borderColor: 'red',
						borderStyle: 'solid'
					},*/
					width: "95%",
				},
			],
		},
		{
			xtype: 'panel',
			layout: {
				type: 'hbox'
			},
			items: [
				{  xtype: 'checkboxfield', id: 'check-filters-year' },
				{
					xtype: 'multislider',
					reference: 'filters_year',
					id: 'slider-filters-year',
					fieldLabel: 'Year',
					labelWidth: 50,
					name: 'year',
					values: [1900, 2020],
					increment: 1,
					minValue: 1900,
					maxValue: 2020,
					constrainThumbs: false,
					disabled: true,
					width: "95%"
				}
			],
		},
		{
			xtype: 'panel',
			layout: {
				type: 'hbox'
			},
			items: [
				{  xtype: 'checkboxfield', id: 'check-filters-secs' },
				{
					xtype: 'multislider',
					reference: 'filters_secs',
					id: 'slider-filters-secs',
					fieldLabel: 'Length',
					labelWidth: 50,
					name: 'secs',
					values: [0, 1200],
					increment: 10,
					minValue: 0,
					maxValue: 1200,
					constrainThumbs: false,
					disabled: true,
					width: "95%"
				}
			],
		},
		{
			xtype: 'panel',
			layout: {
				type: 'hbox'
			},
			items: [
				{  xtype: 'checkboxfield', id: 'check-filters-playcount' },
				{
					xtype: 'multislider',
					reference: 'filters_playcount',
					id: 'slider-filters-playcount',
					fieldLabel: 'Play count',
					labelWidth: 70,
					name: 'playcount',
					values: [0, 100],
					increment: 1,
					minValue: 0,
					maxValue: 100,
					constrainThumbs: false,
					disabled: true,
					width: "95%"
				}
			],
		},
	],
	layout: {
		type: "vbox",
		align: 'stretch',
//		padding: 5
	},

	initComponent: function() {
		this.callParent( arguments);
		/*
		console.log("Check ");
		console.dir( this.lookupReference('filters_rating'));
		console.dir( this.down('#slider-filters-rating'));
		*/
		this.down('#check-filters-rating').on("change", this.onRatingsCheck, this);
		this.down('#check-filters-year').on("change", this.onYearCheck, this);
		this.down('#check-filters-playcount').on("change", this.onPlaycountCheck, this);
		this.down('#check-filters-secs').on("change", this.onSecsCheck, this);
	},
	onRatingsCheck: function( field, value) {
		this.down('#slider-filters-rating').setDisabled( !value);
	},
	onYearCheck: function( field, value) {
		this.down('#slider-filters-year').setDisabled( !value);
	},
	onPlaycountCheck: function( field, value) {
		this.down('#slider-filters-playcount').setDisabled( !value);
	},
	onSecsCheck: function( field, value) {
		this.down('#slider-filters-secs').setDisabled( !value);
	},

	buildFiltersForDB: function( ) {
		var filters = {};

		var fr = this.down('#slider-filters-rating');
		if( !fr.isDisabled()) {
			var rv = fr.getValues();
			Object.assign( filters, { rating: { ratingFrom: rv[0], ratingTo: rv[1] } });
		}
		var fy = this.down('#slider-filters-year');
		if( !fy.isDisabled()) {
			var yv = fy.getValues();
			Object.assign( filters, { year: { yearFrom: yv[0], yearTo: yv[1] } });
		}
		var fp = this.down('#slider-filters-playcount');
		if( !fp.isDisabled()) {
			var pv = fp.getValues();
			Object.assign( filters, { playcount: { playcountFrom: pv[0], playcountTo: pv[1] } });
		}
		var fs = this.down('#slider-filters-secs');
		if( !fs.isDisabled()) {
			var sv = fs.getValues();
			Object.assign( filters, { secs: { secsFrom: sv[0], secsTo: sv[1] } });
		}

		return filters;
	},	

});