Ext.define('LMSplaylistEditor.ux.SlimGridAlbumsNewMusic', {
	extend: 'LMSplaylistEditor.ux.SlimGridAlbumsBase',
	xtype: 'slim-grid-albumnewmusic',
	alias: 'widget.slim-grid-albumnewmusic',
	id: 'SlimGridAlbumsNewMusic',
	requires: ['Ext.slider.Single'],
	controller: 'SlimSearchController',
	
//	store: 'AlbumNewMusic',
	store: Ext.create( 'LMSplaylistEditor.store.AlbumNewMusic', {storeId:'AlbumNewMusic'}),
	listeners: {
		itemdblclick: 'onSearchAlbumsDoubleClick',
		scope: 'controller'
    },

	initComponent: function() {
		
		this.tbar = Ext.create('Ext.toolbar.Toolbar', {
			items: [
				{ xtype: 'tbspacer' },
				{
					xtype: 'component',
					html: 'Limit:',
					align: 'left'
				},
				{ xtype: 'tbspacer' },
				Ext.create('Ext.slider.Single',{
					minValue: 10,
					value: 50,
					increment: 10,
					maxValue: 300,
					useTips: true,
					reorderable: false,
					width: 100,
					listeners: {
						changecomplete: {fn: function( slider, newValue) {
							this.getNewMusic( newValue);
						}, scope: this}
					}
				})
			]
		});

		this.callParent( arguments);
		this.on('activate', this.firstInit, this);
	},

	firstInit: function( ) {
		this.getNewMusic( this.down('slider').getValue() );
		this.removeListener('activate', this.firstInit, this);
	},
	
	getNewMusic: function( limit) {
		var args = {
				'cmd': 'getAlbumsNewMusic',
				'limit': limit
			};
		//this.setLoading( true);
		this.getStore().getProxy().setExtraParam('args', Ext.JSON.encode(args));
		this.getStore().load({
			scope: this,
			callback: function(records, operation, success) {
			//this.setLoading( false);
				if( success) {
					this.setTitle( "New Music ("+this.getStore().getTotalCount()+")");
					this.isInitialized = true;
				}
			}
		});
	}
});