Ext.define('LMSplaylistEditor.ux.SlimGridArtistsSearch', {
	extend: 'LMSplaylistEditor.ux.SlimGridArtistsBase',
	requires: [],
	xtype: 'slim-grid-artists-search',
	alias: 'widget.slim-grid-artists-search',
	id: 'SlimGridArtistsSearch',
	reference: 'slim_grid_artists_search',
	controller: 'SlimSearchController',
	
//	store: 'ArtistSearchResults',
	store: Ext.create( 'LMSplaylistEditor.store.ArtistSearchResults', {storeId:'ArtistSearchResults'}),
	features: [],
	scrollable: 'vertical',
	listeners: {
		itemdblclick: 'onSearchArtistsDoubleClick',
		scope: 'controller'
    },

	tbar: [
			{
				xtype: 'textfield',
				id: 'artistsearchresults-field-artist-name',
				reference: 'artistsearchresults_field_artist_name',
				allowBlank: false,
				minLength: 2,
				hidelLabel: true,
				listeners: {
					specialkey: 'onArtistSearchFieldSubmit',
					scope: 'controller'
				}
			},{
				xtype: 'button', 
				tooltip: 'Search',
				id: "artistsearchresults-button-search",
				iconCls: 'x-fa fa-search',
				scale: 'small',
				listeners: {
					click: 'onArtistSearchButtonClick',
					scope: 'controller'
				}
			}
	],
	
	initComponent: function() {
		this.callParent( arguments);
		//this.on('expand', function() { console.log('expand') });
	},
/*	beforeShow: function() {
		console.log("SlimGridArtistsSearch: beforeShow");
	},*/
	search: function( name) {
		var args = {
			cmd: 'getAllArtists',
			search: name
			};
		this.getStore().getProxy().setExtraParam('args', Ext.JSON.encode(args));
		this.getStore().loadPage(1, {
			scope: this,
			callback: function(records, operation, success) {
				if( success) {
					this.setTitle( "Artists ("+this.getStore().getTotalCount()+")");
				}
			}
		});
	}	
	
	
});