Ext.define('LMSplaylistEditor.ux.SlimMenuContextTrackDetail', {
	extend: 'Ext.menu.Menu',
	requires: ['LMSplaylistEditor.Utils', 'LMSplaylistEditor.RuntimeConfig'],

	grid: {},
	currentTrackId: 689687,
	currentTrackName: "",
	currentTrackRec: {},
	
	initComponent: function() {

		this.items = [{
			text: 'Show tags',
//			icon: "images/information.png",
			iconCls: 'x-fa fa-info-circle',
			handler: this.showTagInfo,
			scope: this
			},{
			text: 'Show lyrics',
			iconCls: 'x-fa fa-align-left',
//			icon: "images/text_dropcaps.png",
			handler: this.showLyricsInfo,
			scope: this
			}];
		
		this.callParent( arguments);
	},	
	showTagInfo: function() {
		var args= {
					cmd: 'getTagsFromTrack',
					player: 'dummy',
					trackid: this.currentTrackRec.get('id')
				};
				
		Ext.data.JsonP.request({
			url: LMSplaylistEditor.RuntimeConfig.config.JSONPURL,
			params: {
				args: Ext.JSON.encode(args)
			},
			callback: function(success, result) {
				if (success && result.results.length > 0) {
					var theText = "";
					Ext.each( result.results, function( v) {
						theText += (v.name+"<br>");
					});
					Ext.create('LMSplaylistEditor.ux.InfoWin', {
						title: "Tags for \""+this.currentTrackRec.get('name')+'" by '+this.currentTrackRec.get('artistName'),
						html: theText,
						modal: false,
						width: '40%',
						height: '50%'
					}).show();
				}
			},
			scope: this
		});
	},
	showLyricsInfo: function( i, e) {
		if( !this.lyricsTip) {
			this.lyricsTip = Ext.create('Ext.tip.ToolTip', {
					closable: true,
					autoHide: false,
					hideDelay: 1000,
					dismissDelay: 0,
					draggable: true
				});
		}
		this.lyricsTip.setTitle("\""+this.currentTrackRec.get('name')+'" by '+this.currentTrackRec.get('artistName') );
		this.lyricsTip.update(this.currentTrackRec.get('lyrics'));
		if (!this.lyricsTip.isVisible() ) {
			this.lyricsTip.showAt( e.getXY() );
		} else {
			this.lyricsTip.setActive( true);
		}	},
	// rec.get('id'), rec.get('name')
	setCurrentTrackInfo: function( rec) {
		this.currentTrackRec = rec;
		this.down('menuitem[text="Show lyrics"]').setDisabled( !rec.get('lyrics'));
	}

});