Ext.define('LMSplaylistEditor.ux.SlimMenuContextTrackImages', {
	extend: 'Ext.menu.Menu',
	requires: ['LMSplaylistEditor.Utils', 'LMSplaylistEditor.ux.CoverWin', 'LMSplaylistEditor.RuntimeConfig'],
	
	grid: {},
	currentTrackId: 689687,
	currentTrackName: "",
	currentArtistName: "",
	
	title: "Images",
	
	initComponent: function() {

		this.items = [{
			text: 'Please wait...',
			iconCls: 'x-fa fa-clock-o',
			}];
		
		this.callParent( arguments);
		this.on('beforeshow', this.buildMenu, this);
	},
	
	buildMenu: function() {
//		console.log( "trackid:"+ this.currentTrackId);

var args= {
				cmd: 'getImagesForTrack',
				player: "dummy",
				trackid: this.currentTrackId
			};
				
		Ext.data.JsonP.request({
			url: LMSplaylistEditor.RuntimeConfig.config.JSONPURL,
			params: {
				args: Ext.JSON.encode(args)
			},
			callback: function(success, result) {
				if (success && result.results.length > 0) {
					var items = [];
					var me = this;
					Ext.each( result.results, function(v) {
						var sit = Ext.create('Ext.menu.Item',{
							text: v.name + " ("+v.width+"x"+v.height+")",
							plain: false,
							iconCls: 'x-fa fa-image',
							handler: function( item, event) {
								Ext.create('LMSplaylistEditor.ux.CoverWin', {
									title: v.name + " (\""+me.currentTrackName+'"'+" by "+me.currentArtistName+")",
									currentImageRec: v,
									allImages: result.results,
									currentTrackName: me.currentTrackName,
									currentArtistName: me.currentArtistName
								}).show();
							}
						});
						items.push( sit);
					});
					this.removeAll();
					this.add( items);
				}
			},
			scope: this
		});
	},
	setCurrentInfo: function( tid, tname, aname) {
		this.currentTrackId = tid;
		this.currentTrackName = tname;
		this.currentArtistName = aname;
	}

});