Ext.define('LMSplaylistEditor.ux.SlimWinPlaylistSelect', {
	extend: 'Ext.window.Window',
	title: 'Choose playlist',
	closable: false,
	closeAction: 'hide',
	width: 350,
	height: "80%",
	modal: true,
	layout: {
		type: 'fit'
	},
	buttons: [{
		text: 'Load',
		handler: function() {
			var selPlaylists = [];
			var win = this.up('window');
			var plsGrid = win.down('#genregrid');
			
			var s = plsGrid.getSelectionModel();
			Ext.each (s.getSelection(), function( v) {
				selPlaylists.push( v.get('id'));
			});
			
			if( selPlaylists.length != 0) {
				win.fireEvent("plsSelectLoadPlaylist", selPlaylists, LMSplaylistEditor.RuntimeConfig.config.OPS_MODE_REPLACE);
			}
			win.hide();
			s.deselectAll();

//			console.dir( win.selPlaylists);
		}
	},{
		text: 'Cancel',
		handler: function() {
			var win = this.up('window');
			win.hide();
		}
	}],
	items: [
		{
			xtype: 'gridpanel',
			id: 'genregrid',
			store: 'AllPlaylists',
			selModel: Ext.create('Ext.selection.CheckboxModel', { mode: 'SINGLE'}),
			columns: [{
				header: 'Playlist',
				dataIndex: 'playlist',
				flex: 1,
				filter: true
				}],
			frame: true,
			layout: {
				type: 'fit'
			}
		}
	],
});