Ext.define('LMSplaylistEditor.ux.SlimWinRate', {
	extend: 'Ext.Window',
	id: 'SlimWinRate',
	requires: ['LMSplaylistEditor.Utils', 'Ext.slider.Single'],
	closeAction: 'hide',
	modal: false,
	width: '60%',
	height: '50%',
	title: "Rate Tracks",
	layout: {
		type: "fit"
	},
	
	
	initComponent: function() {
		
		this.buttons = 	[{
				xtype: 'splitbutton',
				id: 'win-rate-button-rate-5',
				text: 'Rate *****',
				icon: 'images/thumb_up.png',
				handler: function() {
					this.rateTracks(100);
				},
				menu: {
					id: 'win-rate-ratemenu',
					items: [{
						text: 'Rate ****',
						id: 'win-rate-button-rate-4',
						icon: 'images/thumb_up.png',
						handler: function() {
							this.rateTracks(80);
							},
						scope: this
						},{
						text: 'Rate ***',
						id: 'win-rate-button-rate-3',
						icon: 'images/thumb_up.png',
						handler: function() {
							this.rateTracks(60);
							},
						scope: this
						},{
						text: 'Rate **',
						id: 'win-rate-button-rate-2',
						icon: "images/thumb_down.png",
						handler: function() {
							this.rateTracks(40);
							},
						scope: this
						},{
						text: 'Rate *',
						id: 'win-rate-button-rate-1',
						icon: 'images/thumb_down.png',
						handler: function() {
							this.rateTracks(20);
							},
						scope: this
						},{
						text: 'Remove rating',
						id: 'win-rate-button-rate-0',
						icon: 'images/cross.png',
						handler: function() {
							this.rateTracks(0);
							},
						scope: this
						},
						'-',
						Ext.create('Ext.slider.Single',{
							id: 'win-rate-button-rate-slider',
							minValue: 0,
							value: 0,
							increment: 10,
							maxValue: 100,
							useTips: true,
							plain: true
						})]
				},
				scope: this
			},{
				text: 'Cancel',
				handler: function() {
					this.close();
				},
				scope: this
		}];

		this.items = [
			this.getPanelRate()
		];

		this.callParent( arguments);
		this.down('#win-rate-button-rate-slider').on( "changecomplete" , function( slider, newValue) { 
					this.rateTracks( newValue);
					slider.findParentByType('menu').hide();
				}, this);
	},
	getPanelRate: function() {
		this.panelRate = Ext.create('LMSplaylistEditor.ux.SlimGridTracksRate');
		return this.panelRate;
	},
	rateTracks: function( rating) {
		this.fireEvent('rateTracks', this.panelRate.getStore(), rating);
		this.close();
	}

});